
var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

function logMessage(message) {
	aConsoleService.logStringMessage("Sage++: " + message);
}

function dateFormat(date, twelveHourClock, format) {
	function padout(number) { return (number < 10) ? '0' + number : number; }

	if(!format) {
		format = 0;
	}

	var dayOfMonth = date.getDate();

	var day;
	switch (date.getDay()) {
		case 0: day = strRes.getString("date_sunday_short"); break
		case 1: day = strRes.getString("date_monday_short"); break
		case 2: day = strRes.getString("date_tuesday_short"); break
		case 3: day = strRes.getString("date_wednesday_short"); break
		case 4: day = strRes.getString("date_thursday_short"); break
		case 5: day = strRes.getString("date_friday_short"); break
		case 6: day = strRes.getString("date_saturday_short"); break
	}

	var month, monthNum;
	monthNum = date.getMonth() + 1;
	switch (monthNum) {
		case 1: month = strRes.getString("date_january_short"); break
		case 2: month = strRes.getString("date_february_short"); break
		case 3: month = strRes.getString("date_march_short"); break
		case 4: month = strRes.getString("date_april_short"); break
		case 5: month = strRes.getString("date_may_short"); break
		case 6: month = strRes.getString("date_june_short"); break
		case 7: month = strRes.getString("date_july_short"); break
		case 8: month = strRes.getString("date_august_short"); break
		case 9: month = strRes.getString("date_september_short"); break
		case 10: month = strRes.getString("date_october_short"); break
		case 11: month = strRes.getString("date_november_short"); break
		case 12: month = strRes.getString("date_december_short"); break
	}

	var year = date.getYear() + 1900;

	var date_str;
	switch(format) {
		case 0:
			date_str = day + ", " + month + " " + dayOfMonth + ", " + year;
			break
		case 1:
			date_str = monthNum + "/" + dayOfMonth + "/" + year;
			break
	}

	var hours = date.getHours(), minutes = padout(date.getMinutes()), seconds = padout(date.getSeconds());
	var adjhours, time_str;
	if(twelveHourClock) {
		adjhours = (hours == 0) ? 12 : ((hours < 13) ? hours : hours-12);
		time_str = adjhours + ":" + minutes + ((hours < 12) ? " AM" : " PM");
	} else {
		time_str = hours + ":" + minutes;
	}
	return date_str + " " + time_str;
}



var CommonFunc = {

	//VERSION:  "",                     // Removed by Higmmer (Use SageppOverlay.appVersion instead)
	USER_AGENT: "Mozilla/5.0 (Sage++)", // Modified by Higmmer

	//----- Modified by Higmmer : Start ----->
	PREFS_PREFIX:				"extensions.sagepp.",

	FEED_FOLDER_ID:				"new_folder_id",
	LAST_VERSION:				"last_version",
	//USER_CSS_ENABLE:			"user_css.enable", //
	USER_CSS_SELECT:			"user_css.select", // Replaced by Higmmer
	USER_CSS_PATH:				"user_css.path",
	ALLOW_ENCODED_CONTENT:		"allow_encoded_content",
	AUTO_FEED_TITLE:			"auto_feed_title",
	RENDER_FEEDS:				"render_feeds",
	TWELVE_HOUR_CLOCK:			"twelve_hour_clock",
	FEED_ITEM_ORDER:			"feed_item_order",
	FEED_DISCOVERY_MODE:		"feed_discovery_mode",

	FORCE_SHOW_SEPARATOR:		"force_show_separator",
	OPEN_NEW_TAB:				"open_new_tab",
	OPEN_NEW_TAB_FOREGROUND:	"open_new_tab.foreground",
	MARK_AS_READ_ON_CLOSING:	"mark_as_read_on_closing",
	RENDER_FEEDS_FOLDER_DEFAULT:"render_feeds.folder.default",
	RENDER_FEEDS_FOLDER_PATH:	"render_feeds.folder.path",
	RENDER_FEEDS_TO_CACHE:		"render_feeds.cache",             //
	CACHE_EXPIRE_DAYS:			"render_feeds.cache.expire_days", //
	SHOW_UPDATE_COUNT:			"show_updated_feed_count",        //
	HIDE_NO_UPDATED_FEEDS:		"hide_noupdated_feeds",           // (from Sage-Too)
	HIDE_NO_UPDATED_FOLDERS:	"hide_noupdated_folders",         //
	AUTO_CHECK_FEEDS_ENABLE: 	"auto_check_feeds.enable",        //
	AUTO_CHECK_FEEDS_INTERVAL:	"auto_check_feeds.interval",      //
	AUTO_CHECK_FEEDS_STARTUP:	"auto_check_feeds.startup",       //
	AUTO_CHECK_STARTUP_ONCE:	"auto_check_feeds.startup.once",
	AUTO_CHECK_STARTUP_TARGET:	"auto_check_feeds.startup.target",
	AUTO_CHECK_TARGET:			"auto_check_feeds.target",
	HTML_FILTER_METHOD:			"html_filter_method",
	FILTER_ACCEPT_TAGS:			"filter.accept_tags",
	FILTER_ACCEPT_SCHEMES:		"filter.accept_schemes",
	FILTER_CSS_REJECT_REGEXP:	"filter.reject_css_regexp",
	FILTER_ADBLOCK_REGEXP:		"filter.adblock_regexp",
	FILTER_ADBLOCK_TITLE:		"filter.adblock_title",
	FILTER_DEBUG_MODE:			"filter.debug_mode",
	ENCLOSURE_IGNORE_FILETYPES:	"enclosure.ignore_filetypes",
	ENCLOSURE_ICONIZE:			"enclosure.iconize",                   // (from Sage-Too)
	CHECK_UPDATE_TIMEOUT:		"update_check.timeout",
	CHECK_UPDATE_RT_REFRESH:	"update_check.realtime_refresh_count", // (from Sage-Too)
	ALERT_ON_UPDATE:			"update_check.alert_on_update",
	AUTO_UPDATE_ENABLE:			"auto_update.enable",
	AUTO_UPDATE_LIMIT:			"auto_update.limit",
	AUTO_UPDATE_UNIFY_FEED:		"auto_update.unify_feed",
	USER_SCRIPT_ENABLE:			"user_script.enable",
	USER_SCRIPT_PATH:			"user_script.path",
	SBM_ADD_URL:				"sbm.add_url",
	SBM_URL_FILTER:				"sbm.url_filter",
	INFORMATION_FEED_URL:		"information.feed_url",
	INFORMATION_TITLE:			"information.title",
	SETTINGS_ADV_SELECTED_TAB:	"settings.advanced.selected_tab",
	NEED_TO_MIGRATE:			"need_to_migrate_from",

	/*OLD_PREFS: {
		FILTER_ACCEPT_TAGS:			{name:"sage.filter_accept_tags", type:"str"},
		FILTER_ACCEPT_SCHEMES:		{name:"sage.filter_accept_schemes", type:"str"},
		FILTER_CSS_REJECT_REGEXP:	{name:"sage.filter_css_reject_regexp", type:"str"},
		FILTER_ADBLOCK_REGEXP:		{name:"sage.filter_adblock_regexp", type:"str"},
		FILTER_ADBLOCK_TITLE:		{name:"sage.filter_adblock_title", type:"wstr"},
		FILTER_DEBUG_MODE:			{name:"sage.filter_debug_mode", type:"bool"},
		ENCLOSURE_IGNORE_FILETYPES:	{name:"sage.enclosure_ignore_filetypes", type:"str"},
		CHECK_UPDATE_TIMEOUT:		{name:"sage.check_update_timeout", type:"int"},
		AUTO_UPDATE_LIMIT:			{name:"sage.auto_update_limit", type:"int"},
		SBM_ADD_URL:				{name:"sage.sbm_add_url", type:"str"},
		SBM_URL_FILTER:				{name:"sage.sbm_url_filter", type:"str"}
	},*/
	//<----- Modified by Higmmer : End -----


// ++++++++++ ++++++++++ Bookmark RDF ++++++++++ ++++++++++

	NC_NS:				"http://home.netscape.com/NC-rdf#",
	BM_NAME:			"http://home.netscape.com/NC-rdf#Name",
	BM_URL:				"http://home.netscape.com/NC-rdf#URL",
	BM_FEEDURL:			"http://home.netscape.com/NC-rdf#FeedURL",
	BM_DESCRIPTION:		"http://home.netscape.com/NC-rdf#Description",
	BM_LAST_VISIT:		"http://home.netscape.com/WEB-rdf#LastVisitDate",
	BM_LAST_MODIFIED:	"http://home.netscape.com/WEB-rdf#LastModifiedDate",

	//----- Added by Higmmer : Start ----->
	RDF_TYPE_BOOKMARK:	"http://home.netscape.com/NC-rdf#Bookmark",
	RDF_TYPE_LIVEMARK:	"http://home.netscape.com/NC-rdf#Livemark",
	RDF_TYPE_FOLDER:	"http://home.netscape.com/NC-rdf#Folder",
	RDF_TYPE_SEPARATOR:	"http://home.netscape.com/NC-rdf#BookmarkSeparator",
	//<----- Added by Higmmer : End -----

	RDF_NS:				"http://www.w3.org/1999/02/22-rdf-syntax-ns#",
	RDF_TYPE:			"http://www.w3.org/1999/02/22-rdf-syntax-ns#type",

	XUL_NS:				"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",

	STATUS_UPDATE:		"updated",
	STATUS_NO_UPDATE:	"no-updated",
	STATUS_UNKNOWN:		"unknown",
	STATUS_ERROR:		"error",
	STATUS_NO_CHECK:	"no-check",

	//----- Added by Higmmer : Start (for Firefox3) ----->
	ANNO_LASTMODIFIED:	"bookmarkProperties/sagelastmodified",
	ANNO_STATUS:		"bookmarkProperties/sagestatus",
	ANNO_SIGNATURE:		"bookmarkProperties/sagesig",
	ANNO_ORG_QUERY:		"PlacesOrganizer/OrganizerQuery",
	//<----- Added by Higmmer : End -----

	//----- Removed by Higmmer : Start ----->
	/*setBMDSProperty: function(aInput, aArcURI, aNewValue) {
		var changed = false;
		var aOldValue = this.getBMDSTargetByURL(aInput, aArcURI);
		if(typeof(aInput) == "string") {
			aInput = RDF.GetResource(aInput);
		}
		if(typeof(aArcURI) == "string") {
			aArcURI = RDF.GetResource(aArcURI);
		}

		if(typeof(aNewValue) == "string") {
			aNewValue = RDF.GetLiteral(aNewValue);
		} else if(typeof(aNewValue) == "number") {
			aNewValue = RDF.GetIntLiteral(aNewValue);
		}

		if(aArcURI && (aOldValue || aNewValue) && aOldValue != aNewValue) {
			if(aOldValue && !aNewValue) {
				BMDS.Unassert(aInput, aArcURI, aOldValue);
			} else if(!aOldValue && aNewValue) {
				BMDS.Assert(aInput, aArcURI, aNewValue, true);
			} else /* if(aOldValue && aNewValue) *//* {
				BMDS.Change(aInput, aArcURI, aOldValue, aNewValue);
			}
			changed = true;
		}
		return changed;
	},

	getBMDSProperty: function(aInput, aArcURI) {
		if(typeof(aInput) == "string") {
			aInput = RDF.GetResource(aInput);
		}
		if(typeof(aArcURI) == "string") {
			aArcURI = RDF.GetResource(aArcURI);
		}
		return this.getBMDSTargetByURL(aInput, aArcURI).Value;
	},

	getBMDSTargetByURL: function(aInput, aArcURI) {
		if(typeof(aArcURI) == "string") {
			aArcURI = RDF.GetResource(aArcURI);
		}
		var node = BMDS.GetTarget(aInput, aArcURI, true);
		try {
			return node.QueryInterface(kRDFRSCIID);
		} catch(e) {
			try {
				return node.QueryInterface(Components.interfaces.nsIRDFDate);
			} catch(e) {
				return node? node.QueryInterface(kRDFLITIID) : RDF.GetLiteral("");
			}
		}
	},*/
	//<----- Removed by Higmmer : End -----

	getBMDSCChildren: function(aFolderId, bIncludeFolder) { // Modified by Higmmer
		this._folderMap = {};
		var resultArray = [];

		this.addArrayItems(aFolderId, resultArray, bIncludeFolder);

		return resultArray;
	},

	//----- Added by Higmmer : Start ----->
	addArrayItems: function(folderId, resArray, includeFolder) { // from Sage-Too
		var rootNode = PlacesUtils.getFolderContents(folderId).root; // Modified by Higmmer
		for (var i = 0; i < rootNode.childCount; i ++) {
			var node = rootNode.getChild(i);
			this._folderMap[node.itemId] = rootNode; // Added by Higmmer
			if (node.type == node.RESULT_TYPE_URI) {
				resArray.push(node);
			} else if (node.type == node.RESULT_TYPE_FOLDER) {
				if(_impl.nodeIsLivemarkContainer(node)) {
					resArray.push(node);
				} else {
					if(includeFolder) resArray.push(node); // Added by Higmmer
					this.addArrayItems(node.itemId, resArray, includeFolder); // Modified by Higmmer
				}
			}
		}
	},

	//----- Removed by Higmmer : Start ----->
	// This function is obsolete. Use _impl.setLastModified instead.
	/*addVisit: function(node) { // from Sage-Too
		var historyService = Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsINavHistoryService);
		var uri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		uri.spec = node.uri;
		var time = new Date().valueOf();
		time = time * 1000;
		historyService.addVisit(uri, time, null, 3, false, 0);
	},*/
	//<----- Removed by Higmmer : End -----

	getItemAnnotation: function(itemId, annoName, defaultValue) {
		var result = arguments.length > 2 ? defaultValue : "";
		try{ result = PlacesUtils.annotations.getItemAnnotation(itemId, annoName); } catch(e){}
		return result;
	},
	//<----- Added by Higmmer : End -----



// ++++++++++ ++++++++++ CharCode ++++++++++ ++++++++++

	convertCharCodeFrom: function(aString, aCharCode) {
		var UConvID = "@mozilla.org/intl/scriptableunicodeconverter";
		var UConvIF  = Components.interfaces.nsIScriptableUnicodeConverter;
		var UConv = Components.classes[UConvID].getService(UConvIF);

		var tmpString = "";
		try {
			UConv.charset = aCharCode;
			tmpString = UConv.ConvertFromUnicode(aString);
		} catch(e) {
			tmpString = null;
		}
		return tmpString;
	},


	getInnerText: function(aNode) {
		if(!aNode.hasChildNodes()) return "";

		var resultArray = new Array();
		var walker = aNode.ownerDocument.createTreeWalker(aNode, NodeFilter.SHOW_CDATA_SECTION | NodeFilter.SHOW_TEXT, null, false);
		while(walker.nextNode()) {
			resultArray.push(walker.currentNode.nodeValue);
		}
		return resultArray.join('').replace(/^\s+|\s+$/g, "");
	},


	loadText: function(aURI) {
		var	URI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
		URI.spec = aURI;

		var IOService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		var channel = IOService.newChannelFromURI(URI);
		var stream	= channel.open();
		var scriptableStream = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
		scriptableStream.init(stream);

		var fileContents = scriptableStream.read(scriptableStream.available());

		scriptableStream.close();
		stream.close();

		return fileContents;
	},


// ++++++++++ ++++++++++ preferences ++++++++++ ++++++++++

	setPrefValue : function(aPrefString, aPrefType, aValue) {
		var nsISupportsString = Components.interfaces.nsISupportsString;
		var xpPref = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefBranch);

		aPrefString = this.PREFS_PREFIX + aPrefString; // Added by Higmmer

		try {
			switch(aPrefType) {
				case "wstr":
					var string = Components.classes['@mozilla.org/supports-string;1'].createInstance(nsISupportsString);
					string.data = aValue;
					return xpPref.setComplexValue(aPrefString, nsISupportsString, string);
					break;
				case "str":
					return xpPref.setCharPref(aPrefString, aValue);
					break;
				case "int":
					aValue = parseInt(aValue);
					return xpPref.setIntPref(aPrefString, aValue);
					break;
				case "bool":
				default:
					if(typeof(aValue) == "string") {
						aValue = (aValue == "true");
					}
					return xpPref.setBoolPref(aPrefString, aValue);
					break;
			}
		} catch(e) {
		}
		return null;
	},

	getPrefValue : function(aPrefString, aPrefType, aDefault) {
		var nsISupportsString = Components.interfaces.nsISupportsString;
		var xpPref = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefBranch);

		aPrefString = this.PREFS_PREFIX + aPrefString; // Added by Higmmer
		if(xpPref.getPrefType(aPrefString) == xpPref.PREF_INVALID) {
			return aDefault;
		}

		try {
			switch (aPrefType) {
				case "wstr":
					return xpPref.getComplexValue(aPrefString, nsISupportsString).data;
					break;
				case "str":
					return xpPref.getCharPref(aPrefString).toString();
					break;
				case "int":
					return xpPref.getIntPref(aPrefString);
					break;
				case "bool":
				default:
					return xpPref.getBoolPref(aPrefString);
					break;
			}
		} catch(e) {
		}
		return aDefault;
	},

	prefHasUserValue: function(aPrefString) { // Added by Higmmer
		var xpPref = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefBranch);
		aPrefString = this.PREFS_PREFIX + aPrefString; // Added by Higmmer

		try {
			return xpPref.prefHasUserValue(aPrefString);
		} catch(e) {
			return false;
		}
	},

	clearPref: function(aPrefString) {
		var xpPref = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefBranch);
		aPrefString = this.PREFS_PREFIX + aPrefString; // Added by Higmmer

		try {
			xpPref.clearUserPref(aPrefString);
			return true;
		} catch(e) {
			return false;
		}
	},

	// remove all preferences
	removePrefs: function() {
		var xpPref = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);

		var prefBranch = xpPref.getBranch(this.PREFS_PREFIX); // Modified by Higmmer

		try {
			prefBranch.deleteBranch("");
			return true;
		} catch(e) {
			return false;
		}
	},

	addPrefListener: function(aPrefString, aFunc) {
		aPrefString = this.PREFS_PREFIX + aPrefString; // Added by Higmmer

		var prefObserver;
		try {
			prefObserver = {
				domain: aPrefString,
				observe: aFunc
			};

			var pbi = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
			pbi.addObserver(prefObserver.domain, prefObserver, false);
		} catch(e) {
			alert(e);
			prefObserver = null;
		}

		return prefObserver;
	},

	removePrefListener: function(aObserver) {
		var prefObserver;
		try {
			var pbi = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
			pbi.removeObserver(aObserver.domain, aObserver);
		} catch(e) {
			alert(e)
		}
	},

	// takes a version string, returns an integer triple containing (major version, minor version, patch level)
	versionStrDecode: function(versionStr) {
		var regexp = /([0-9]*)\.([0-9]*)\.([0-9]*)/;
		var result = regexp.exec(versionStr);
		return Array(parseInt(result[1]), parseInt(result[2]), parseInt(result[3]));
	},

	// takes a version triple, returns an integer
	versionToInt: function(versionTriple) {
		return versionTriple[0]*1000 + versionTriple[1]*100 + versionTriple[2]; // Modified by Higmmer
	},

	// takes two version triples, returns 1 if the first is more recent, 0 otherwise
	versionCompare: function(versionA, versionB) {
		if(this.versionToInt(versionA) > this.versionToInt(versionB)) {
			return 1;
		} else {
			return 0;
		}
	},

	// takes a version triple, returns a formatted version string
	versionString: function(version, pretty) {
		var formatted;
		if(pretty) {
			formatted = version[0].toString() + '.' + version[1].toString();
			formatted += "." + (version[2] !== undefined ? version[2] : "x"); // Modified by Higmmer
			if(version[3] !== undefined) formatted += "." + version[3];       // Added by Higmmer
		} else {
			formatted = version[0].toString() + '.' + version[1].toString() + '.' + version[2].toString();
		}
		return formatted;
	},

	//----- Added by Higmmer : Start ----->
	getAppVersion: function() {
		var pv = function(v){ return parseInt(v) || 0; }
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo).version.split(".");
		return { major:pv(appInfo[0]), minor:pv(appInfo[1]), micro:pv(appInfo[2]), build:pv(appInfo[3]) };
	}
	//<----- Added by Higmmer : End -----
};


//----- Added by Higmmer : Start ----->
// Fix: Script Injection Vulnerability
// Some character entities can turn into HTML tags although "Allow HTML tags" is disabled.
// ( Moved from sagepp.js / Each [M] mark means "This line is modified by Higmmer" )
function htmlToText(aStr) {
	var	formatConverter = Components.classes["@mozilla.org/widget/htmlformatconverter;1"].createInstance(Components.interfaces.nsIFormatConverter);
	var fromStr = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	fromStr.data = aStr.replace(/&/g, "&amp;"); // [M]
	var toStr = { value: null };

	try {
		formatConverter.convert("text/html", fromStr, fromStr.toString().length, "text/unicode", toStr, {});
	} catch(e) {
		return "Converting Error"; // [M]
	}
	if(toStr.value) {
		toStr = toStr.value.QueryInterface(Components.interfaces.nsISupportsString);
		return toStr.toString().replace(/&(?!([a-z]+|#[0-9]+|#x[0-9a-f]+);)/gi, "&amp;"); // [M]
	}
	return "Converting Error"; // [M]
}

// Show updated feed count on folders
var UpdateCounter = {
	_count:null, _titleMap:null, _folderMapCache:null, _feedsCache:null, _rootFolderId:null, _lastFolderId:null,
	_countStrPattern:/ \(([0-9]+)\) $/,
	_stopUpdate:false,

	update: function(changedFolder, invalidateAll, forceRefresh, preventRedraw) { try {
		if(this._stopUpdate) return;

		var enable = CommonFunc.getPrefValue(CommonFunc.SHOW_UPDATE_COUNT, "bool", false);
		if(!enable && !forceRefresh) return;
		if(forceRefresh || !changedFolder || !this._count) invalidateAll = true;

		//logMessage("UpdateCounter#update: start"); var stime = (new Date()).getTime();

		this._init(invalidateAll);
		this._countUpdatedFeeds(enable, changedFolder, invalidateAll);
		this._updateTitle(enable);
		this._redrawTree(changedFolder, preventRedraw);

		//var etime = (new Date()).getTime(); logMessage("UpdateCounter#update: end in " + (etime-stime) + "(ms)");
	} catch(e) { logMessage(e); } },

	activate: function() {
		this._stopUpdate = false;
	},
	deactivate: function() {
		this._stopUpdate = true;
	},

	_init: function(invalidateAll) {
		this._rootFolderId = _impl.getRootFolderId();
		if(invalidateAll) {
			this._count = {};
			this._folderMapCache = null;
		}
		this._titleMap = {};
	},
	_resetCount: function(folder, stopFolderId, negCount) {
		if(!folder) return;
		var itemId = _impl.getItemId(folder);
		if(!this._count[itemId]) this._count[itemId] = 0;
		else if(negCount) this._count[itemId] -= negCount;
		if(itemId == stopFolderId) return;
		else this._resetCount(this._getParent(folder), stopFolderId, negCount);
	},
	_increment: function(folder) {
		if(!folder) return;
		var itemId = _impl.getItemId(folder);
		if(!this._count[itemId]) this._count[itemId] = 0;
		this._count[itemId]++;
		if(itemId == this._rootFolderId) return;
		else this._increment(this._getParent(folder));
	},
	_getCountStr: function(folder) {
		var itemId = _impl.getItemId(folder);
		return (this._count && this._count[itemId]) ? " (" + this._count[itemId] + ") " : "";
	},
	_getDiff: function(prevStatus, newStatus) {
		if(prevStatus == 0) prevStatus = CommonFunc.STATUS_UPDATE;
		return (prevStatus != CommonFunc.STATUS_UPDATE && newStatus == CommonFunc.STATUS_UPDATE) ? +1
		     : (prevStatus == CommonFunc.STATUS_UPDATE && newStatus != CommonFunc.STATUS_UPDATE) ? -1
		     : 0;
	},
	_getRealTitle: function(folder) {
		var title = _impl.getTitle(folder);
		return title.match(this._countStrPattern) ? RegExp.leftContext : title;
	},
	_getParent: function(item) {
		try{ if(item.parent) return item.parent; } catch(e){}
		return this._folderMapCache ? this._folderMapCache[_impl.getItemId(item)] : null;
	},
	_getFeeds: function(folder, rebuildAll) {
		var feeds;
		if(rebuildAll || !folder || !this._folderMapCache) {
			//logMessage("UpdateCounter#getFeeds: rebuildAll");
			feeds = CommonFunc.getBMDSCChildren(this._rootFolderId, true);
			this._folderMapCache = CommonFunc._folderMap;
			this._feedsCache = null;
			this._lastFolderId = null;
		} else {
			var itemId = _impl.getItemId(folder);
			if(itemId != this._lastFolderId || !this._feedsCache) {
				//logMessage("UpdateCounter#getFeeds: inFolder: " + _impl.getTitle(folder));
				feeds = this._feedsCache = CommonFunc.getBMDSCChildren(folder.itemId, true);
				this._lastFolderId = itemId;
			} else {
				//logMessage("UpdateCounter#getFeeds: inFolder (cache): " + _impl.getTitle(folder));
				feeds = this._feedsCache;
			}
		}
		return feeds.slice(0);
	},
	_nodeIsFeed: function(node) {
		return node.type == node.RESULT_TYPE_URI || _impl.nodeIsLivemarkContainer(node);
	},
	_folderIsUpdated: function(folder, forceView) {
		var updated = this._countStrPattern.test(_impl.getTitle(folder));
		if(!updated && forceView) updated = !CommonFunc.getPrefValue(CommonFunc.SHOW_UPDATE_COUNT, "bool", false);
		return updated;
	},
	_countUpdatedFeeds: function(enable, changedFolder, invalidateAll) {
		var feeds = this._getFeeds(changedFolder, invalidateAll);
		if(!invalidateAll) {
			this._resetCount(changedFolder, this._rootFolderId, this._count[_impl.getItemId(changedFolder)])
			for each(var item in feeds) {
				if(!this._nodeIsFeed(item)) this._resetCount(item, _impl.getItemId(changedFolder), this._count[_impl.getItemId(item)]);
			}
			feeds.unshift(changedFolder);
		}
		for(var i = feeds.length - 1; i >= 0; i--) {
			var item = feeds[i];
			if(enable && this._nodeIsFeed(item)) {
				if(_impl.getStatus(item) == CommonFunc.STATUS_UPDATE) this._increment(this._getParent(item));
			}
			if(!this._nodeIsFeed(item)) this._makeTitle(item);
		}
	},
	_makeTitle: function(folder) {
		if(!folder) return;
		var itemId = _impl.getItemId(folder); if(itemId == this._rootFolderId) return;
		var title = _impl.getTitle(folder);
		var cstr = this._getCountStr(folder);
		if(title.match(this._countStrPattern)) title = title.replace(this._countStrPattern, cstr); else title += cstr;
		this._titleMap[itemId] = { folder:folder, title:title };
		this._makeTitle(this._getParent(folder));
	},
	_updateTitle: function(enable) {
		for(var itemId in this._titleMap) {
			var folder = this._titleMap[itemId].folder;
			var title = this._titleMap[itemId].title;
			if(_impl.getTitle(folder) != title) {
				PlacesUIUtils.ptm.editItemTitle(folder.itemId, title).doTransaction();
			}
		}
		var winTitle = "";
		var total = this._count[this._rootFolderId];
		if(enable && total > 0) {
			winTitle = strRes.getString("WINDOW_ONUPDATE_NEW") + " " + total + " " + strRes.getString("WINDOW_ONUPDATE_FEEDS") + " - ";
		}
		winTitle += strRes.getString("WINDOW_TITLE");
		document.title = winTitle;
	},
	_redrawTree: function(changedFolder, preventRedraw) {
		if(preventRedraw) return;
		var tree = document.getElementById("bookmarksTree"), view = tree.view;
		var index = view.selection.currentIndex, diff = view.rowCount;
		_impl.invalidateAllTreeView(view);
		if(view.rowCount > 0) {
			diff = view.rowCount - diff;
			if(diff < -1) {
				index += diff + 1;
				if(index < 0 || index >= view.rowCount) index = 0;
				view.selection.select(index);
			}
			else if(view.selection.currentIndex < 0) view.selection.select(0);
			tree.treeBoxObject.ensureRowIsVisible(view.selection.currentIndex);
		}
	},
	onEditProperty: function(tree) {
		var node = tree.view.nodeForTreeIndex(tree.currentIndex);
		if(!node) return;

		switch (true) {
		case PlacesUtils.nodeIsSeparator(node):
		case _impl.nodeIsLivemarkItem(node):
			return;
		case !CommonFunc.getPrefValue(CommonFunc.SHOW_UPDATE_COUNT, "bool", false):
		case UpdateCounter._nodeIsFeed(node):
		case !UpdateCounter._folderIsUpdated(node):
			goDoCommand("placesCmd_show:info");
			return;
		}

		var realTitle = null, count = 0;
		if(node.title.match(this._countStrPattern)) {
			realTitle = RegExp.leftContext;
			count = parseInt(RegExp.$1);
		}

		var params = { node:node, realTitle:realTitle, result:null };
		window.openDialog("chrome://sagepp/content/dialogs/editFolderProperties/editFolderProperties.xul", "", "chrome,modal,centerscreen", params);
		if(params.result) {
			var result = params.result;
			if(count > 0) result.title += " (" + count + ") ";
			PlacesUIUtils.ptm.beginBatch();
			[
				PlacesUIUtils.ptm.editItemTitle(node.itemId, result.title),
				PlacesUIUtils.ptm.editItemDescription(node.itemId, result.description)
			].forEach(function(txn){
				PlacesUIUtils.ptm.doTransaction(txn);
			});
			PlacesUIUtils.ptm.endBatch();
		}
	}
};


// for maintain compatibility between different Firefox versions...
const FirefoxVersion = {
	_version: null,
	get version(){ return this._version || (this._version = CommonFunc.getAppVersion()); },
	get major()  { return this.version.major; },
	get minor()  { return this.version.minor; },
	get micro()  { return this.version.micro; },
	get number() { return this.version.major * 1000 + this.version.minor * 100 + this.version.micro; }
};

function DoOnlyFx2(thisObj, func) {
	throw "DoOnlyFx2 - Unsupported function call";
}
function DoOnlyFx3(thisObj, func) {
	throw "DoOnlyFx3 - Unsupported function call, use BranchByFxVer instead";
}
function BranchByFxVer(thisObj, funcInfo) {
	if(arguments.length != 2) throw "BranchByFxVer - Invalid function call";
	var args = Array.prototype.slice.call(arguments, 2);
	for(var v = FirefoxVersion.major; v >= 3; v--) {
		var fn = "fx" + v;
		if((fn in funcInfo) && (typeof funcInfo[fn] == "function")) return funcInfo[fn].apply(thisObj, args);
	}
	throw "BranchByFxVer - can't find executable function";
}
function NullFunction() {
}


var _impl = {
	getItemId: function(node) {
		return node.itemId;
	},
	getTitle: function(node) {
		return node.title;
	},
	getType: function(node) {
		return node.type;
	},
	getUrl: function(node) {
		if(_impl.nodeIsLivemarkContainer(node)) {
			return CommonFunc.getItemAnnotation(node.itemId, PlacesUtils.LMANNO_FEEDURI);
		} else {
			return node.uri;
		}
	},
	getStatus: function(node) {
		return CommonFunc.getItemAnnotation(node.itemId, CommonFunc.ANNO_STATUS, CommonFunc.STATUS_UPDATE);
	},
	getSignature: function(node) {
		return CommonFunc.getItemAnnotation(node.itemId, CommonFunc.ANNO_SIGNATURE);
	},
	setStatusAndSignature: function(node, status, signature) {
		try {
			var anno = PlacesUtils.annotations;
			if(status)
				anno.setItemAnnotation(node.itemId, CommonFunc.ANNO_STATUS, status, 0, anno.EXPIRE_NEVER);
			if(signature)
				anno.setItemAnnotation(node.itemId, CommonFunc.ANNO_SIGNATURE, signature, 0, anno.EXPIRE_NEVER);
		} catch(e) {}
	},
	setLastModified: function(node, lastModified) {
		try {
			var anno = PlacesUtils.annotations;
			anno.setItemAnnotation(node.itemId, CommonFunc.ANNO_LASTMODIFIED, lastModified, 0, anno.EXPIRE_NEVER);
		} catch(e) {}
	},
	getLastModified: function(node) {
		return parseInt(CommonFunc.getItemAnnotation(node.itemId, CommonFunc.ANNO_LASTMODIFIED, 0));
	},
	getRootFolderId: function() {
		return CommonFunc.getPrefValue(CommonFunc.FEED_FOLDER_ID, "str", PlacesUIUtils.allBookmarksFolderId);
	},
	changeRootFolderId: function(newFolderId, oldFolderId) {
		if(newFolderId != oldFolderId) {
			var anno = PlacesUtils.annotations;
			if(oldFolderId && CommonFunc.getItemAnnotation(oldFolderId, CommonFunc.ANNO_ORG_QUERY) == "SageppRoot") {
				try{ anno.removeItemAnnotation(oldFolderId, CommonFunc.ANNO_ORG_QUERY); } catch(e){}
			}
		}
		return newFolderId;
	},
	setBookmarksTreePlace: function(tree, folderId) {
		tree.place = "place:folder=" + folderId + "&queryType=1";
	},
	invalidateAllTreeView: function(view) {
		try {
			view.invalidateContainer(null);
		} catch(e) {
			logMessage("Error occurred in _impl.invalidateAllTreeView\n" + e);
		}
	},
	nodeIsLivemarkContainer: function(node) {
		return PlacesUtils.nodeIsFolder(node)
		    && PlacesUtils.annotations.itemHasAnnotation(node.itemId, PlacesUtils.LMANNO_FEEDURI);
	},
	nodeIsLivemarkItem: function(node) {
		return node.parent && _impl.nodeIsLivemarkContainer(node.parent);
	}
};
//<----- Added by Higmmer : End -----
